<?php
/**
 * Plugin spxwslider
 *
 * @package SPX
 * @version	
 * @date	07/07/2014
 * @author	JE-EVRARD
 **/
class spxwunslider extends plxPlugin {
	
	
	/**
	 * Constructeur de la classe spxwslider
	 *
	 * @param	default_lang	langue par dfaut utilise par PluXml
	 * @return	null
	 * @author	
	 **/
	public function __construct($default_lang) {
		
		# Appel du constructeur de la classe plxPlugin (obligatoire)
		parent::__construct($default_lang);
		
		# droits pour accder  la page config.php du plugin
		$this->initconfiguration();
		$this->setConfigProfil(PROFIL_ADMIN);
		$this->spxname="spxwunslider";

		# Dclarations des hooks
		if(!defined('PLX_ADMIN')) {
			$this->addHook('ThemeEndHead', 'addCssLibrairy');
			$this->addHook('ThemeEndBody', 'addJSlibrairy');
		}
		
		$this->addHook('spxwunslider::getUnsliderID', 'getUnsliderID');
		$this->addHook('spxwunslider::getUnsliderTitle', 'getUnsliderTitle');
	}

	public function initconfiguration() {
		# VARIOUS PARAMS
		$this->setParam('spxdatas_widget', '1', 'string');
		$this->setParam('spxshortcodes_shortcode', '1', 'string');
		
		if (plxUtils::strCheck($this->getParam('title'))=="") $this->setParam('title', '1', 'string');
		if (plxUtils::strCheck($this->getParam('description'))=="") $this->setParam('description', '1', 'string');
		if (plxUtils::strCheck($this->getParam('button'))=="") $this->setParam('button', '1', 'string');
		if (plxUtils::strCheck($this->getParam('speed'))=="") $this->setParam('speed', '500', 'numeric');
		if (plxUtils::strCheck($this->getParam('dots'))=="") $this->setParam('dots', '1', 'string');
		if (plxUtils::strCheck($this->getParam('bt_window'))=="") $this->setParam('bt_window', '1', 'string');
		if (plxUtils::strCheck($this->getParam('dataformat'))=="") $this->setParam('dataformat', 'xml', 'string');
		
		$aProfils = $this->get_aprofil();
		foreach($aProfils as $key=>$val) { 
			if (plxUtils::strCheck($this->getParam('profiladmin'.$key))=="") $this->setParam('profiladmin'.$key,$this->get_adminright_list(),'string');
			
		}
		foreach($aProfils as $key=>$val) { 
			if (plxUtils::strCheck($this->getParam('profiladmincontent'.$key))=="") $this->setParam('profiladmincontent'.$key,$this->get_adminrightcontent_list(),'string');
		}
		
	}
	/**
	 * Mthode qui ajoute le fichier css 
	 *
	 * @return	stdio
	 * @author	Evrard jerome
	 **/
	
	public function addCssLibrairy() {
		
		//<link href="'.PLX_PLUGINS.'/spxwunslider/css/site.css" rel="stylesheet" type="text/css" />
		//echo "\n".' ';
	
	}
	/**
	 * Mthode qui ajoute les lib et init
	 *
	 * @return	
	 * @author	Evrard jerome
	 **/
	public function addJSlibrairy() {
		$dots='';
		
		if ($this->getParam('dots') =='1')
			$dots='dots: true,';
		$speed='speed: '.$this->getParam('speed');
		
		echo "\n".'
		<script type="text/javascript">
		/* <![CDATA[ */
		!window.jQuery && document.write(\'<script  type="text/javascript" src="'.PLX_PLUGINS.'spxwunslider/assets/jquery-2.0.3.min.js"><\/script>\');
		/* !]]> */
		</script>

		<!-- Include required JS files -->
		<script type="text/javascript" src="'.PLX_PLUGINS.'/spxwunslider/assets/unslider/unslider.min.js"></script>
 		
		
		<script type="text/javascript">
		
				jQuery(function($){
					if($(".spxwunslider").length){
						if(window.chrome) {
							$(".spxwunslider li").css("background-size", "100% 100%");
						}
			
						$(".spxwunslider").unslider({
							fluid: true,
							'.$dots.'
							'.$speed.'
						});
				
					}
			   	})
			</script>';
	}
	
	/**
	 * Mthode qui retourne les profils utilisateurs
	 *
	 * @return	// foreach($aProfils as $key=>$val) {
	 * @author	
	 **/
	
	public function get_aprofil() {
		# Tableau des profils
		return array(
			PROFIL_ADMIN => L_PROFIL_ADMIN,
			PROFIL_MANAGER => L_PROFIL_MANAGER,
			PROFIL_MODERATOR => L_PROFIL_MODERATOR,
			PROFIL_EDITOR => L_PROFIL_EDITOR,
			PROFIL_WRITER => L_PROFIL_WRITER
		);
		
	}
	
	# define admin right list for sliders list
	public function get_adminright_list() {
		return "view create modify delete";
	}
	
	# define admin right list for slider content
	public function get_adminrightcontent_list() {
		return "create modify delete";
	}
	
	public function get_tableuserlevel($param='profiladmin') {
		$s='';
		$aProfils = $this->get_aprofil();
		foreach($aProfils as $key=>$val) {
			$sright = $this->getParam($param.$key);
			$aright = explode (" ", $sright);
			foreach($aright as $key2=>$val2) {
				if ($val2=="view"){
					$s.=$key.',';
					break;	
				}
			}
		}
		return substr ($s, 0, -1);
	}
	
	public function get_rightCMDlevel($param='profiladmin') {
		$s='';
		$aProfils = $this->get_aprofil();
		foreach($aProfils as $key=>$val) {
			$sright = $this->getParam($param.$key);
			$aright = explode (" ", $sright);
			$create='0';
			$modify='0';
			$delete='0';
			foreach($aright as $key2=>$val2) {
				if ($val2=="create"){
					$create='1';
				}
				if ($val2=="modify"){
					$modify='1';
				}
				if ($val2=="delete"){
					$delete='1';
				}
			}
			$s.=$key.':'.$create.$modify.$delete.',';
		}
		return substr ($s, 0, -1);
		//return '3:010,4:010';
	}
	
	public function write_table() {
		$xml =$this->get_table_spxdatas();
		$path = PLX_PLUGINS.'spxwunslider/spxdatas/table/table.php';
		$bwrite = plxUtils::write($xml,$path);
		/*
		if($bwrite) {
			return plxMsg::Info(L_SAVE_SUCCESSFUL);		
		} else {
			return plxMsg::Error(L_SAVE_ERR.' '.PLX_ROOT.$this->aConf['categories']);
		}
		*/
	}
	
	# get html content for slider
	public function getUnsliderID($id='001') {
		$filter = 'spxwunsliders_id='.$id;
		$s='';
		$s.='<div class="spxwunslider">';
				$s.='<ul>';
					$s.= $this->get_slider_request($filter) ;
				
				$s.='</ul>';
			$s.='</div>';
		return $s;
	}
	
	# get html content for slider
	public function getUnsliderTitle($name) {
		$filter = 'title='.$name;
		$s='';
		$s.='<div class="spxwunslider">';
				$s.='<ul>';
					$s.= $this->get_slider_request($filter) ;
				
				$s.='</ul>';
			$s.='</div>';
		return $s;
	}
	
	public function get_slider_request($filter) {
		$plxMotor = plxMotor::getInstance();
		$IMAGEPATH = isset($plxMotor->aConf['medias']) ? plxUtils::getRacine().$plxMotor->aConf['medias'] : plxUtils::getRacine().$plxMotor->aConf['images'];	
		//echo ("test2=".$IMAGEPATH);
		
		$s='<li style="background-image: url(\''.$IMAGEPATH.'#image\');">';
						if ($this->getParam('title') =='1')
							$s.='<h1>#title</h1>';
						if ($this->getParam('description') =='1')
							$s.='<p>#description</p>';
						if ($this->getParam('button') =='1') {
							$target='';
							if ($this->getParam('bt_window') =='1')
								$target = 'target="_blank"';
							
							$s.='<a class="btn display#want_bt" '.$target.' href="#bt_url">#bt_title</a>';
						}
					$s.='</li>';
		
		
		$o= array();
		$o["table"]="spxwunsliders";
		$o["out"]="html";
		
		$o["format"]='#slider_content';
		$o["filter"]=$filter;
		$o["subtable_format"]["slider_content"]=$s;
		$tmp = $plxMotor->plxPlugins->aPlugins["spxdatas"];
		return $tmp->getData($o);
		
	}
	
	# define admin right list
	public function get_table_spxdatas() {
		$dataformat='';
		if ($this->getParam('dataformat') =="json")
			$dataformat='dataformat="json"';
		$s='';
		$s.='<table name="spxwunsliders" maxparam="2" groupe="spxwunslider" '.$dataformat.' tableuserlevel="'.$this->get_tableuserlevel().'" rightCMDlevel="'.$this->get_rightCMDlevel().'" >';
		$s.='<description><![CDATA[<p>List of sliders</p>]]></description>';
			$s.='<column>';
					$s.='<parameter  name="title" type="cdata" option="textinput/30/100" ></parameter>';
					$s.='<parameter  name="slider_content" type="cdata" option="subtable/spxwunslider" ></parameter>';
			$s.='</column>';
		$s.='</table>';
		
		
		$s.='<table name="spxwunslider" maxparam="2" groupe="spxwunslider" type="subtable" order="true" '.$dataformat.' rightCMDlevel="'.$this->get_rightCMDlevel('profiladmincontent').'" >';
		$s.='<description><![CDATA[<p>Your slider</p>]]></description>';
			$s.='<column>';
				if ($this->getParam('title') =='1')
					$s.='<parameter  name="title" type="cdata" option="textinput/30/100" ></parameter>';
				$s.='<parameter  name="image" type="cdata" option="image" ></parameter>';
				if ($this->getParam('description') =='1')
					$s.='<parameter  name="description" type="cdata" option="textarea/40/10" ></parameter>';
				if ($this->getParam('button') =='1'){
					$s.='<parameter  name="want_bt" type="string" option="boolean" ></parameter>';
					$s.='<parameter  name="bt_title" type="cdata" option="textinput/30/100" ></parameter>';
					$s.='<parameter  name="bt_url" type="cdata" option="textinput/30/100" ></parameter>';
					
				}
			$s.='</column>';
		$s.='</table>';
		return $s;
	}
	
	# getloc call by spxdatas
	public function get_loc($mylang) {
		$filename = PLX_PLUGINS.$this->spxname.'/spxdatas/table/table_loc/'.$mylang.'/admin.php';
		$LANG = array();
		if(is_file($filename)) {
			include($filename);
		}
		return $LANG;
	}
	
	# getdefaultloc use by config traduction
	public function get_loc_default($mylang) {
		$filename = PLX_PLUGINS.$this->spxname.'/spxdatas/table/table_loc/'.$mylang.'/admin_default.php';
		
		$LANG = array();
		if(is_file($filename)) {
			include($filename);
		}
		return $LANG;
		
	}
	
	# record loc for spxdatas
	public function set_loc($mylang) {
		$atraddefault = $this->get_loc_default($mylang);
		$LANG="LANG";
		$out="<?php
		
					$$LANG = array(";
		foreach($atraddefault as $key=>$val) {
			
			$code = 'admin_loc_'.$trad.'_'.$key;
			$check = $this->getParam($code);
			if ($check=="-") {
				$loc="";
			}else if ($check=="") {
				$loc=$val;
			}else{
				$loc=$check;
			}
			$loc = str_replace("'", "\'", $loc);
			
			$out.="'".$key."'			=> '".$loc."',";
		}
		$out.="	
					);
					?>";
		$fileloc = PLX_PLUGINS.$this->spxname.'/spxdatas/table/table_loc/'.$mylang.'/admin.php';
		plxUtils::write($out,$fileloc);
	}

}

?>